/* suidbatch.c - setuid news wrapper for send-batches, to be called
 *               from uucico
 */

#include <unistd.h>
#include <string.h>

#define OUT(s) __write(2,(s),sizeof(s))

int main (int argc, char **argv)
{
	char *sysname, *mode;

	if (argc != 3 && argc != 2) {
		OUT("suidbatch: wrong number of arguments (want 1 or 2)\n");
		exit(1);
	}
	mode = argv[2];		/* might be NULL */
	sysname = argv[1];
	if (sysname[strcspn(sysname, "/ \t\n")]) {
		OUT("suidbatch: illegal system name.\n");
		exit (1);
	}
	if (setsid() < 0) {
		OUT("suidbatch: setsid failed\n");
		exit (1);
	}
	setreuid (geteuid(), -1 /* geteuid() */ );
	execl ("/usr/lib/batcher/send-batches-now", "send-batches-now",
		sysname, mode, NULL);
	OUT("suidbatch: execl(send-batches-now) failed\n");
	exit (1);
}
